{-----------------------------------------------------------------------------
 Unit Name: CocoComments
 Author:    Administrator
 Purpose: Container for GUI-model of ATG File - Holds the Comment-Handling section
 -----------------------------------------------------------------------------}


unit CocoComments;

interface

uses
  Windows, Messages, SysUtils, Classes,
  pbStrLib, DataFile, CocoTokens, CocoToken;

type
  TCocoComments = class(TComponent)
  private
    FCommentText: string;
    FIsEditing: boolean;
    procedure SetCommentText(const Value: string);
    procedure SetIsEditing(const Value: boolean);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function GetATG: string;
    procedure StartComment;
    procedure StartFROM;
    procedure StartTO;
    procedure StartNested;
    procedure AddCommentText(const ct: string);
    procedure Clear;
  published
    { Published declarations }
    property CommentText: string read FCommentText write SetCommentText;
    property IsEditing: boolean read FIsEditing write SetIsEditing;
  end;

implementation

{ TCocoComments }

procedure TCocoComments.AddCommentText(const ct: string);
begin
  FCommentText := FCommentText + Trim(ct);
end;

procedure TCocoComments.Clear;
begin
  FCommentText := '';
end;

function TCocoComments.GetATG: string;
begin
  if not FIsEditing then
  begin
    Result := FCommentText + #13#10;
  end
  else
    Result := '<!--Modified Text Here-->' + CRLF;
end;

procedure TCocoComments.SetCommentText(const Value: string);
begin
  FCommentText := Value;
end;

procedure TCocoComments.SetIsEditing(const Value: boolean);
begin
  FIsEditing := Value;
end;

procedure TCocoComments.StartComment;
begin
  FCommentText := FCommentText + #13#10 + 'COMMENTS ';
end;

procedure TCocoComments.StartFROM;
begin
  FCommentText := FCommentText + 'FROM ';
end;

procedure TCocoComments.StartNested;
begin
  FCommentText := FCommentText + ' NESTED';
end;

procedure TCocoComments.StartTO;
begin
  FCommentText := FCommentText + ' TO ';
end;

end.
