unit ProdCheck2ParserComponent;

interface

uses
  Windows, Messages, SysUtils, Classes, ProdCheck2Parser;

type
  TProdCheck2ParserComponent = class(TComponent)
  private
    { Private declarations }
    FProdCheck2Parser: TProdCheck2Parser;
    FInput: string;
    FOutput: string;
    procedure SetInput(const Value: string);
    procedure SetOutput(const Value: string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(Aowner: TComponent); override;
    destructor Destroy; override;
    function Execute: boolean;
  published
    { Published declarations }
    property Input: string read FInput write SetInput;
    property Output: string read FOutput write SetOutput;
  end;


function ExecuteProdCheck2Parser(const sInput: string; var sOutput: string): boolean;


implementation

uses ProdCheck2Scanner;


function ExecuteProdCheck2Parser(const sInput: string; var sOutput: string): boolean;
begin
  with  TProdCheck2ParserComponent.Create(nil) do
    try
      Input := sInput;
      Result := Execute;
      sOutput := Output;
    finally
      Free;
    end;
end;


{ TProdCheck2ParserComponent }

constructor TProdCheck2ParserComponent.Create(Aowner: TComponent);
begin
  inherited;
  FProdCheck2Parser := TProdCheck2Parser.Create;
end;

destructor TProdCheck2ParserComponent.Destroy;
begin
  FProdCheck2Parser.Free;
  inherited;
end;

function TProdCheck2ParserComponent.Execute: boolean;
begin
  FProdCheck2Parser.SourceString := FInput;
  FProdCheck2Parser.Parse;
  FOutput := FProdCheck2Parser.lst.DataString;
  Result := FProdCheck2Parser.errors = 0;
end;

procedure TProdCheck2ParserComponent.SetOutput(const Value: string);
begin
  FOutput := Value;
end;

procedure TProdCheck2ParserComponent.SetInput(const Value: string);
begin
  FInput := Value;
end;

end.
