// Generated by ParserBuilder @ 12/04/2002 2:29:25 PM

unit SimpleSyntaxCheckerScanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes, pbStrLib, Dialogs;

const
  BlkSize = 16384;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..31] of ^TBufBlock;
  TStartTable = array [0..255] of Integer;
  TGetCH = procedure(pos: longint; var retCh: char) of object;
  TCocoErrorProc = procedure(nr, line, col: Integer; pos: Integer) of object;

type
  TSimpleSyntaxCheckerScanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: Integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: Integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: Integer;
    Fpos: Integer;
    Fcol: Integer;
    FnextCol: Integer;
    FnextPos: Integer;
    Flen: Integer;
    FnextLine: Integer;
    Fline: Integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: Integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure CapChAt(pos: longint; var retChar: char);
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: Integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: Integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: Integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar: char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: Integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: Integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: Integer read Flen write Flen;      (*length of current symbol*)
    property pos: Integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: Integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: Integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: Integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: Integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: Integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation

uses SimpleSyntaxCheckerG (* Symbol Constants *);


const
  no_Sym = NO_SYMB; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

procedure TSimpleSyntaxCheckerScanner.CapChAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := upcase(buf[pos div LBlkSize]^[pos mod LBlkSize]);
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

procedure TSimpleSyntaxCheckerScanner.CharAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TSimpleSyntaxCheckerScanner.Comment: boolean;
label
  999;
var
  level: integer;
  oldLineStart: longint;
begin
  level := 1; 
  oldLineStart := lineStart;
  if (ch = '(') then 
  begin  
    NextCh;
  
    if (ch = '*') then 
    begin    
      NextCh;
    
      while True do 
      begin      
        if (ch = '*') then 
        begin        
          NextCh;
        
          if (ch = ')') then 
          begin          
            DEC(level); 
            NextCh;
          
            if level = 0 then 
            begin 
              Comment := True; 
              goto 999; 
            end
          end
        end 
        else if ch = EF then 
        begin 
          Comment := False; 
          goto 999; 
        end
      
        else 
          NextCh;
      end; (* WHILE TRUE *)
    end 
    else 
    begin    
      if (ch = _CR) or (ch = _LF) then 
      begin      
        DEC(curLine); 
        lineStart := oldLineStart
      end;
    
      DEC(bp); 
      ch := lastCh;
    end;
  end;

  Comment := False;
  999:
end;


procedure TSimpleSyntaxCheckerScanner.Err(nr, line, col, pos: Integer);
begin
  INC(Ferrors)
end;

procedure TSimpleSyntaxCheckerScanner.Get(var sym: Integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc: char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q, cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;
begin (*Get*)
  while (ch = ' ') or
        
    ((ch >= CHR(1)) and (ch <= CHR(31))) do NextCh;
  
  if ((ch = '(')) and Comment then 
  begin 
    Get(sym); 
    EXIT; 
  end;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
      1: if ((ch = '!') or
             
          (ch >= '#') and (ch <= '&') or
             
          (ch >= '*') and (ch <= 'Z') or
             
          (ch = '\') or
             
          (ch >= '^') and (ch <= 'z') or
             
          (ch = '|') or
             
          (ch >= '~')) then 
        begin            
        end 
        else 
        begin 
          sym := identSym; 
          EXIT; 
        end;
     
      2: if ((ch = CHR(0)) or
             
          (ch >= ' ') and (ch <= '!') or
             
          (ch >= '#')) then 
        begin            
        end 
        else if (ch = '"') then 
        begin 
          state := 4; 
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      3: if ((ch = CHR(0)) or
             
          (ch >= ' ') and (ch <= '&') or
             
          (ch >= '(')) then 
        begin            
        end 
        else if (ch = CHR(39)) then 
        begin 
          state := 4; 
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      4: 
      begin 
        sym := stringSym; 
        EXIT; 
      end;
     
      5: if (ch = '.') then 
        begin 
          state := 8; 
        end 
        else 
        begin 
          sym := _lparenSym; 
          EXIT; 
        end;
     
      6: 
      begin 
        sym := _lbrackSym; 
        EXIT; 
      end;
     
      7: 
      begin 
        sym := _lbraceSym; 
        EXIT; 
      end;
     
      8: 
      begin 
        sym := _lparen_pointSym; 
        EXIT; 
      end;
     
      9: 
      begin 
        sym := _rbraceSym; 
        EXIT; 
      end;
     
      10: 
      begin 
        sym := _rbrackSym; 
        EXIT; 
      end;
     
      11: 
      begin 
        sym := _rparenSym; 
        EXIT; 
      end;
     
      12: 
      begin 
        sym := _point_rparenSym; 
        EXIT; 
      end;
     
      13: if ((ch = '!') or
             
          (ch >= '#') and (ch <= '&') or
             
          (ch >= '*') and (ch <= 'Z') or
             
          (ch = '\') or
             
          (ch >= '^') and (ch <= 'z') or
             
          (ch = '|') or
             
          (ch >= '~')) then 
        begin 
          state := 1; 
        end 
        else if (ch = ')') then 
        begin 
          state := 12; 
        end 
        else 
        begin 
          sym := identSym; 
          EXIT; 
        end;
     
      14: 
      begin 
        sym := EOFSYMB; 
        ch := #0; 
        DEC(bp); 
        EXIT 
      end;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TSimpleSyntaxCheckerScanner.GetName(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S, Len);
  while i <= len do
  begin
    CurrentCh(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TSimpleSyntaxCheckerScanner.GetString(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S, len);
  while i <= len do
  begin
    CharAt(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TSimpleSyntaxCheckerScanner.NextCh;
  (* Return global variable ch *)
var 
  cc: char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp, cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TSimpleSyntaxCheckerScanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: integer;
begin (*assert: src has been opened*)
  //  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
    //    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TSimpleSyntaxCheckerScanner.Create;
begin
  inherited;
  lst := TStringStream.Create('');
  src := nil;
  CurrentCh := CapChAt;
  
  start[0] := 14; 
  start[1] := 15; 
  start[2] := 15; 
  start[3] := 15; 
  
  start[4] := 15; 
  start[5] := 15; 
  start[6] := 15; 
  start[7] := 15; 
  
  start[8] := 15; 
  start[9] := 15; 
  start[10] := 15; 
  start[11] := 15; 
  
  start[12] := 15; 
  start[13] := 15; 
  start[14] := 15; 
  start[15] := 15; 
  
  start[16] := 15; 
  start[17] := 15; 
  start[18] := 15; 
  start[19] := 15; 
  
  start[20] := 15; 
  start[21] := 15; 
  start[22] := 15; 
  start[23] := 15; 
  
  start[24] := 15; 
  start[25] := 15; 
  start[26] := 15; 
  start[27] := 15; 
  
  start[28] := 15; 
  start[29] := 15; 
  start[30] := 15; 
  start[31] := 15; 
  
  start[32] := 15; 
  start[33] := 1; 
  start[34] := 2; 
  start[35] := 1; 
  
  start[36] := 1; 
  start[37] := 1; 
  start[38] := 1; 
  start[39] := 3; 
  
  start[40] := 5; 
  start[41] := 11; 
  start[42] := 1; 
  start[43] := 1; 
  
  start[44] := 1; 
  start[45] := 1; 
  start[46] := 13; 
  start[47] := 1; 
  
  start[48] := 1; 
  start[49] := 1; 
  start[50] := 1; 
  start[51] := 1; 
  
  start[52] := 1; 
  start[53] := 1; 
  start[54] := 1; 
  start[55] := 1; 
  
  start[56] := 1; 
  start[57] := 1; 
  start[58] := 1; 
  start[59] := 1; 
  
  start[60] := 1; 
  start[61] := 1; 
  start[62] := 1; 
  start[63] := 1; 
  
  start[64] := 1; 
  start[65] := 1; 
  start[66] := 1; 
  start[67] := 1; 
  
  start[68] := 1; 
  start[69] := 1; 
  start[70] := 1; 
  start[71] := 1; 
  
  start[72] := 1; 
  start[73] := 1; 
  start[74] := 1; 
  start[75] := 1; 
  
  start[76] := 1; 
  start[77] := 1; 
  start[78] := 1; 
  start[79] := 1; 
  
  start[80] := 1; 
  start[81] := 1; 
  start[82] := 1; 
  start[83] := 1; 
  
  start[84] := 1; 
  start[85] := 1; 
  start[86] := 1; 
  start[87] := 1; 
  
  start[88] := 1; 
  start[89] := 1; 
  start[90] := 1; 
  start[91] := 6; 
  
  start[92] := 1; 
  start[93] := 10; 
  start[94] := 1; 
  start[95] := 1; 
  
  start[96] := 1; 
  start[97] := 1; 
  start[98] := 1; 
  start[99] := 1; 
  
  start[100] := 1; 
  start[101] := 1; 
  start[102] := 1; 
  start[103] := 1; 
  
  start[104] := 1; 
  start[105] := 1; 
  start[106] := 1; 
  start[107] := 1; 
  
  start[108] := 1; 
  start[109] := 1; 
  start[110] := 1; 
  start[111] := 1; 
  
  start[112] := 1; 
  start[113] := 1; 
  start[114] := 1; 
  start[115] := 1; 
  
  start[116] := 1; 
  start[117] := 1; 
  start[118] := 1; 
  start[119] := 1; 
  
  start[120] := 1; 
  start[121] := 1; 
  start[122] := 1; 
  start[123] := 7; 
  
  start[124] := 1; 
  start[125] := 9; 
  start[126] := 1; 
  start[127] := 1; 
  
  start[128] := 1; 
  start[129] := 1; 
  start[130] := 1; 
  start[131] := 1; 
  
  start[132] := 1; 
  start[133] := 1; 
  start[134] := 1; 
  start[135] := 1; 
  
  start[136] := 1; 
  start[137] := 1; 
  start[138] := 1; 
  start[139] := 1; 
  
  start[140] := 1; 
  start[141] := 1; 
  start[142] := 1; 
  start[143] := 1; 
  
  start[144] := 1; 
  start[145] := 1; 
  start[146] := 1; 
  start[147] := 1; 
  
  start[148] := 1; 
  start[149] := 1; 
  start[150] := 1; 
  start[151] := 1; 
  
  start[152] := 1; 
  start[153] := 1; 
  start[154] := 1; 
  start[155] := 1; 
  
  start[156] := 1; 
  start[157] := 1; 
  start[158] := 1; 
  start[159] := 1; 
  
  start[160] := 1; 
  start[161] := 1; 
  start[162] := 1; 
  start[163] := 1; 
  
  start[164] := 1; 
  start[165] := 1; 
  start[166] := 1; 
  start[167] := 1; 
  
  start[168] := 1; 
  start[169] := 1; 
  start[170] := 1; 
  start[171] := 1; 
  
  start[172] := 1; 
  start[173] := 1; 
  start[174] := 1; 
  start[175] := 1; 
  
  start[176] := 1; 
  start[177] := 1; 
  start[178] := 1; 
  start[179] := 1; 
  
  start[180] := 1; 
  start[181] := 1; 
  start[182] := 1; 
  start[183] := 1; 
  
  start[184] := 1; 
  start[185] := 1; 
  start[186] := 1; 
  start[187] := 1; 
  
  start[188] := 1; 
  start[189] := 1; 
  start[190] := 1; 
  start[191] := 1; 
  
  start[192] := 1; 
  start[193] := 1; 
  start[194] := 1; 
  start[195] := 1; 
  
  start[196] := 1; 
  start[197] := 1; 
  start[198] := 1; 
  start[199] := 1; 
  
  start[200] := 1; 
  start[201] := 1; 
  start[202] := 1; 
  start[203] := 1; 
  
  start[204] := 1; 
  start[205] := 1; 
  start[206] := 1; 
  start[207] := 1; 
  
  start[208] := 1; 
  start[209] := 1; 
  start[210] := 1; 
  start[211] := 1; 
  
  start[212] := 1; 
  start[213] := 1; 
  start[214] := 1; 
  start[215] := 1; 
  
  start[216] := 1; 
  start[217] := 1; 
  start[218] := 1; 
  start[219] := 1; 
  
  start[220] := 1; 
  start[221] := 1; 
  start[222] := 1; 
  start[223] := 1; 
  
  start[224] := 1; 
  start[225] := 1; 
  start[226] := 1; 
  start[227] := 1; 
  
  start[228] := 1; 
  start[229] := 1; 
  start[230] := 1; 
  start[231] := 1; 
  
  start[232] := 1; 
  start[233] := 1; 
  start[234] := 1; 
  start[235] := 1; 
  
  start[236] := 1; 
  start[237] := 1; 
  start[238] := 1; 
  start[239] := 1; 
  
  start[240] := 1; 
  start[241] := 1; 
  start[242] := 1; 
  start[243] := 1; 
  
  start[244] := 1; 
  start[245] := 1; 
  start[246] := 1; 
  start[247] := 1; 
  
  start[248] := 1; 
  start[249] := 1; 
  start[250] := 1; 
  start[251] := 1; 
  
  start[252] := 1; 
  start[253] := 1; 
  start[254] := 1; 
  start[255] := 1; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TSimpleSyntaxCheckerScanner.Destroy;
begin
  if (src <> nil) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TSimpleSyntaxCheckerScanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 31 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end.
