// Generated by ParserBuilder @ 10/04/2002 10:36:24 PM

unit pcCocoImportTestScanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes, pbStrLib, Dialogs;

const
  BlkSize = 16384;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..31] of ^TBufBlock;
  TStartTable = array [0..255] of Integer;
  TGetCH = procedure(pos: longint; var retCh: char) of object;
  TCocoErrorProc = procedure(nr, line, col: Integer; pos: Integer) of object;

type
  TpcCocoImportTestScanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: Integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: Integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: Integer;
    Fpos: Integer;
    Fcol: Integer;
    FnextCol: Integer;
    FnextPos: Integer;
    Flen: Integer;
    FnextLine: Integer;
    Fline: Integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: Integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure CapChAt(pos: longint; var retChar: char);
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: Integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: Integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: Integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar: char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: Integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: Integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: Integer read Flen write Flen;      (*length of current symbol*)
    property pos: Integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: Integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: Integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: Integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: Integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: Integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation



const
  no_Sym = 60; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

procedure TpcCocoImportTestScanner.CapChAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := upcase(buf[pos div LBlkSize]^[pos mod LBlkSize]);
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

procedure TpcCocoImportTestScanner.CharAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TpcCocoImportTestScanner.Comment: boolean;
label
  999;
var
  level: integer;
  oldLineStart, startLine: longint;
begin
  level := 1; 
  oldLineStart := lineStart;
  if (ch = '/') then 
  begin  
    NextCh;
  
    if (ch = '*') then 
    begin    
      NextCh;
    
      while True do 
      begin      
        if (ch = '*') then 
        begin        
          NextCh;
        
          if (ch = '/') then 
          begin          
            DEC(level); 
            NextCh;
          
            if level = 0 then 
            begin 
              Comment := True; 
              goto 999; 
            end
          end
        end 
        else if (ch = '/') then 
        begin        
          NextCh;
        
          if (ch = '*') then 
          begin 
            INC(level); 
            NextCh 
          end
        end 
        else if ch = EF then 
        begin 
          Comment := False; 
          goto 999; 
        end
      
        else 
          NextCh;
      end; (* WHILE TRUE *)
    end 
    else 
    begin    
      if (ch = _CR) or (ch = _LF) then 
      begin      
        DEC(curLine); 
        lineStart := oldLineStart
      end;
    
      DEC(bp); 
      ch := lastCh;
    end;
  end;

  if (ch = '(') then 
  begin  
    NextCh;
  
    if (ch = '*') then 
    begin    
      NextCh;
    
      while True do 
      begin      
        if (ch = '*') then 
        begin        
          NextCh;
        
          if (ch = ')') then 
          begin          
            DEC(level); 
            NextCh;
          
            if level = 0 then 
            begin 
              Comment := True; 
              goto 999; 
            end
          end
        end 
        else if (ch = '(') then 
        begin        
          NextCh;
        
          if (ch = '*') then 
          begin 
            INC(level); 
            NextCh 
          end
        end 
        else if ch = EF then 
        begin 
          Comment := False; 
          goto 999; 
        end
      
        else 
          NextCh;
      end; (* WHILE TRUE *)
    end 
    else 
    begin    
      if (ch = _CR) or (ch = _LF) then 
      begin      
        DEC(curLine); 
        lineStart := oldLineStart
      end;
    
      DEC(bp); 
      ch := lastCh;
    end;
  end;

  Comment := False;
  999:
end;


procedure TpcCocoImportTestScanner.Err(nr, line, col, pos: Integer);
begin
  INC(Ferrors)
end;

procedure TpcCocoImportTestScanner.Get(var sym: Integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc: char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q, cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;

  procedure CheckLiteral;
  var 
    cc: char;
  begin
    CurrentCh(bp0, cc);
    case cc of
    
      'A': if Equal('ANY') then 
        begin 
          sym := 42; 
        end;
    
      'C': if Equal('CASE') then 
        begin 
          sym := 24; 
        end 
        else if Equal('CHARACTERS') then 
        begin 
          sym := 15; 
        end 
        else if Equal('CHR') then 
        begin 
          sym := 43; 
        end 
        else if Equal('COMMENTS') then 
        begin 
          sym := 19; 
        end 
        else if Equal('COMPILER') then 
        begin 
          sym := 5; 
        end 
        else if Equal('COMPILERFRAME') then 
        begin 
          sym := 32; 
        end 
        else if Equal('COMPILERTARGET') then 
        begin 
          sym := 35; 
        end 
        else if Equal('CONTEXT') then 
        begin 
          sym := 53; 
        end 
        else if Equal('CREATE') then 
        begin 
          sym := 30; 
        end;
    
      'D': if Equal('DELPHICLASS') then 
        begin 
          sym := 9; 
        end 
        else if Equal('DESTROY') then 
        begin 
          sym := 31; 
        end;
    
      'E': if Equal('END') then 
        begin 
          sym := 14; 
        end 
        else if Equal('END_DELPHICLASS') then 
        begin 
          sym := 10; 
        end;
    
      'F': if Equal('FROM') then 
        begin 
          sym := 20; 
        end;
    
      'G': if Equal('GLOBALDECS') then 
        begin 
          sym := 25; 
        end;
    
      'I': if Equal('IGNORE') then 
        begin 
          sym := 23; 
        end;
    
      'N': if Equal('NAMES') then 
        begin 
          sym := 17; 
        end 
        else if Equal('NESTED') then 
        begin 
          sym := 22; 
        end;
    
      'P': if Equal('PARSERFRAME') then 
        begin 
          sym := 33; 
        end 
        else if Equal('PARSERTARGET') then 
        begin 
          sym := 36; 
        end 
        else if Equal('PRAGMAS') then 
        begin 
          sym := 18; 
        end 
        else if Equal('PRIVATE') then 
        begin 
          sym := 26; 
        end 
        else if Equal('PRODUCTIONS') then 
        begin 
          sym := 11; 
        end 
        else if Equal('PROTECTED') then 
        begin 
          sym := 27; 
        end 
        else if Equal('PUBLIC') then 
        begin 
          sym := 28; 
        end 
        else if Equal('PUBLISHED') then 
        begin 
          sym := 29; 
        end;
    
      'S': if Equal('SCANNERFRAME') then 
        begin 
          sym := 34; 
        end 
        else if Equal('SCANNERTARGET') then 
        begin 
          sym := 37; 
        end 
        else if Equal('SYNC') then 
        begin 
          sym := 52; 
        end;
    
      'T': if Equal('TARGETDIRECTORY') then 
        begin 
          sym := 38; 
        end 
        else if Equal('TO') then 
        begin 
          sym := 21; 
        end 
        else if Equal('TOKENS') then 
        begin 
          sym := 16; 
        end;
    
      'U': if Equal('USES') then 
        begin 
          sym := 6; 
        end;
    
      'W': if Equal('WEAK') then 
        begin 
          sym := 47; 
        end;
    
      else 
      begin 
      end
    end
  end;
begin (*Get*)
  while (ch = ' ') or
        
    ((ch >= CHR(9)) and (ch <= CHR(13))) do NextCh;
  
  if ((ch = '/') or (ch = '(')) and Comment then 
  begin 
    Get(sym); 
    EXIT; 
  end;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
      1: if ((ch >= '0') and (ch <= '9') or
             
          (ch >= 'A') and (ch <= 'Z') or
             
          (ch = '_') or
             
          (ch >= 'a') and (ch <= 'z')) then 
        begin            
        end 
        else 
        begin 
          sym := 1; 
          CheckLiteral; 
          EXIT; 
        end;
     
      2: 
      begin 
        sym := 2; 
        EXIT; 
      end;
     
      3: 
      begin 
        sym := 3; 
        EXIT; 
      end;
     
      4: if ((ch >= '0') and (ch <= '9')) then 
        begin            
        end 
        else 
        begin 
          sym := 4; 
          EXIT; 
        end;
     
      5: if ((ch >= '0') and (ch <= '9') or
             
          (ch >= 'A') and (ch <= 'Z') or
             
          (ch = '_') or
             
          (ch >= 'a') and (ch <= 'z')) then 
        begin            
        end 
        else 
        begin 
          sym := 61; 
          EXIT; 
        end;
     
      6: if ((ch = CHR(0)) or
             
          (ch >= ' ') and (ch <= '!') or
             
          (ch >= '#')) then 
        begin            
        end 
        else if ((ch = CHR(10)) or
                
          (ch = CHR(13))) then 
        begin 
          state := 3; 
        end 
        else if (ch = '"') then 
        begin 
          state := 2; 
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      7: if ((ch = CHR(0)) or
             
          (ch >= ' ') and (ch <= '&') or
             
          (ch >= '(')) then 
        begin            
        end 
        else if ((ch = CHR(10)) or
                
          (ch = CHR(13))) then 
        begin 
          state := 3; 
        end 
        else if (ch = CHR(39)) then 
        begin 
          state := 2; 
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      8: 
      begin 
        sym := 7; 
        EXIT; 
      end;
     
      9: 
      begin 
        sym := 8; 
        EXIT; 
      end;
     
      10: 
      begin 
        sym := 12; 
        EXIT; 
      end;
     
      11: if (ch = '.') then 
        begin 
          state := 14; 
        end 
        else if (ch = '>') then 
        begin 
          state := 25; 
        end 
        else if (ch = ')') then 
        begin 
          state := 27; 
        end 
        else 
        begin 
          sym := 13; 
          EXIT; 
        end;
     
      12: 
      begin 
        sym := 39; 
        EXIT; 
      end;
     
      13: 
      begin 
        sym := 40; 
        EXIT; 
      end;
     
      14: 
      begin 
        sym := 41; 
        EXIT; 
      end;
     
      15: if (ch = '.') then 
        begin 
          state := 26; 
        end 
        else 
        begin 
          sym := 44; 
          EXIT; 
        end;
     
      16: 
      begin 
        sym := 45; 
        EXIT; 
      end;
     
      17: 
      begin 
        sym := 46; 
        EXIT; 
      end;
     
      18: 
      begin 
        sym := 48; 
        EXIT; 
      end;
     
      19: 
      begin 
        sym := 49; 
        EXIT; 
      end;
     
      20: 
      begin 
        sym := 50; 
        EXIT; 
      end;
     
      21: 
      begin 
        sym := 51; 
        EXIT; 
      end;
     
      22: if (ch = '.') then 
        begin 
          state := 24; 
        end 
        else 
        begin 
          sym := 54; 
          EXIT; 
        end;
     
      23: 
      begin 
        sym := 55; 
        EXIT; 
      end;
     
      24: 
      begin 
        sym := 56; 
        EXIT; 
      end;
     
      25: 
      begin 
        sym := 57; 
        EXIT; 
      end;
     
      26: 
      begin 
        sym := 58; 
        EXIT; 
      end;
     
      27: 
      begin 
        sym := 59; 
        EXIT; 
      end;
     
      28: 
      begin 
        sym := 0; 
        ch := #0; 
        DEC(bp); 
        EXIT 
      end;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TpcCocoImportTestScanner.GetName(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S, Len);
  while i <= len do
  begin
    CurrentCh(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TpcCocoImportTestScanner.GetString(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S, len);
  while i <= len do
  begin
    CharAt(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TpcCocoImportTestScanner.NextCh;
  (* Return global variable ch *)
var 
  cc: char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp, cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TpcCocoImportTestScanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: integer;
begin (*assert: src has been opened*)
  //  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
    //    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TpcCocoImportTestScanner.Create;
begin
  inherited;
  lst := TStringStream.Create('');
  src := nil;
  CurrentCh := CharAt;
  
  start[0] := 28; 
  start[1] := 29; 
  start[2] := 29; 
  start[3] := 29; 
  
  start[4] := 29; 
  start[5] := 29; 
  start[6] := 29; 
  start[7] := 29; 
  
  start[8] := 29; 
  start[9] := 29; 
  start[10] := 29; 
  start[11] := 29; 
  
  start[12] := 29; 
  start[13] := 29; 
  start[14] := 29; 
  start[15] := 29; 
  
  start[16] := 29; 
  start[17] := 29; 
  start[18] := 29; 
  start[19] := 29; 
  
  start[20] := 29; 
  start[21] := 29; 
  start[22] := 29; 
  start[23] := 29; 
  
  start[24] := 29; 
  start[25] := 29; 
  start[26] := 29; 
  start[27] := 29; 
  
  start[28] := 29; 
  start[29] := 29; 
  start[30] := 29; 
  start[31] := 29; 
  
  start[32] := 29; 
  start[33] := 29; 
  start[34] := 6; 
  start[35] := 29; 
  
  start[36] := 5; 
  start[37] := 29; 
  start[38] := 29; 
  start[39] := 7; 
  
  start[40] := 15; 
  start[41] := 16; 
  start[42] := 29; 
  start[43] := 12; 
  
  start[44] := 8; 
  start[45] := 13; 
  start[46] := 11; 
  start[47] := 29; 
  
  start[48] := 4; 
  start[49] := 4; 
  start[50] := 4; 
  start[51] := 4; 
  
  start[52] := 4; 
  start[53] := 4; 
  start[54] := 4; 
  start[55] := 4; 
  
  start[56] := 4; 
  start[57] := 4; 
  start[58] := 29; 
  start[59] := 9; 
  
  start[60] := 22; 
  start[61] := 10; 
  start[62] := 23; 
  start[63] := 29; 
  
  start[64] := 29; 
  start[65] := 1; 
  start[66] := 1; 
  start[67] := 1; 
  
  start[68] := 1; 
  start[69] := 1; 
  start[70] := 1; 
  start[71] := 1; 
  
  start[72] := 1; 
  start[73] := 1; 
  start[74] := 1; 
  start[75] := 1; 
  
  start[76] := 1; 
  start[77] := 1; 
  start[78] := 1; 
  start[79] := 1; 
  
  start[80] := 1; 
  start[81] := 1; 
  start[82] := 1; 
  start[83] := 1; 
  
  start[84] := 1; 
  start[85] := 1; 
  start[86] := 1; 
  start[87] := 1; 
  
  start[88] := 1; 
  start[89] := 1; 
  start[90] := 1; 
  start[91] := 18; 
  
  start[92] := 29; 
  start[93] := 19; 
  start[94] := 29; 
  start[95] := 1; 
  
  start[96] := 29; 
  start[97] := 1; 
  start[98] := 1; 
  start[99] := 1; 
  
  start[100] := 1; 
  start[101] := 1; 
  start[102] := 1; 
  start[103] := 1; 
  
  start[104] := 1; 
  start[105] := 1; 
  start[106] := 1; 
  start[107] := 1; 
  
  start[108] := 1; 
  start[109] := 1; 
  start[110] := 1; 
  start[111] := 1; 
  
  start[112] := 1; 
  start[113] := 1; 
  start[114] := 1; 
  start[115] := 1; 
  
  start[116] := 1; 
  start[117] := 1; 
  start[118] := 1; 
  start[119] := 1; 
  
  start[120] := 1; 
  start[121] := 1; 
  start[122] := 1; 
  start[123] := 20; 
  
  start[124] := 17; 
  start[125] := 21; 
  start[126] := 29; 
  start[127] := 29; 
  
  start[128] := 29; 
  start[129] := 29; 
  start[130] := 29; 
  start[131] := 29; 
  
  start[132] := 29; 
  start[133] := 29; 
  start[134] := 29; 
  start[135] := 29; 
  
  start[136] := 29; 
  start[137] := 29; 
  start[138] := 29; 
  start[139] := 29; 
  
  start[140] := 29; 
  start[141] := 29; 
  start[142] := 29; 
  start[143] := 29; 
  
  start[144] := 29; 
  start[145] := 29; 
  start[146] := 29; 
  start[147] := 29; 
  
  start[148] := 29; 
  start[149] := 29; 
  start[150] := 29; 
  start[151] := 29; 
  
  start[152] := 29; 
  start[153] := 29; 
  start[154] := 29; 
  start[155] := 29; 
  
  start[156] := 29; 
  start[157] := 29; 
  start[158] := 29; 
  start[159] := 29; 
  
  start[160] := 29; 
  start[161] := 29; 
  start[162] := 29; 
  start[163] := 29; 
  
  start[164] := 29; 
  start[165] := 29; 
  start[166] := 29; 
  start[167] := 29; 
  
  start[168] := 29; 
  start[169] := 29; 
  start[170] := 29; 
  start[171] := 29; 
  
  start[172] := 29; 
  start[173] := 29; 
  start[174] := 29; 
  start[175] := 29; 
  
  start[176] := 29; 
  start[177] := 29; 
  start[178] := 29; 
  start[179] := 29; 
  
  start[180] := 29; 
  start[181] := 29; 
  start[182] := 29; 
  start[183] := 29; 
  
  start[184] := 29; 
  start[185] := 29; 
  start[186] := 29; 
  start[187] := 29; 
  
  start[188] := 29; 
  start[189] := 29; 
  start[190] := 29; 
  start[191] := 29; 
  
  start[192] := 29; 
  start[193] := 29; 
  start[194] := 29; 
  start[195] := 29; 
  
  start[196] := 29; 
  start[197] := 29; 
  start[198] := 29; 
  start[199] := 29; 
  
  start[200] := 29; 
  start[201] := 29; 
  start[202] := 29; 
  start[203] := 29; 
  
  start[204] := 29; 
  start[205] := 29; 
  start[206] := 29; 
  start[207] := 29; 
  
  start[208] := 29; 
  start[209] := 29; 
  start[210] := 29; 
  start[211] := 29; 
  
  start[212] := 29; 
  start[213] := 29; 
  start[214] := 29; 
  start[215] := 29; 
  
  start[216] := 29; 
  start[217] := 29; 
  start[218] := 29; 
  start[219] := 29; 
  
  start[220] := 29; 
  start[221] := 29; 
  start[222] := 29; 
  start[223] := 29; 
  
  start[224] := 29; 
  start[225] := 29; 
  start[226] := 29; 
  start[227] := 29; 
  
  start[228] := 29; 
  start[229] := 29; 
  start[230] := 29; 
  start[231] := 29; 
  
  start[232] := 29; 
  start[233] := 29; 
  start[234] := 29; 
  start[235] := 29; 
  
  start[236] := 29; 
  start[237] := 29; 
  start[238] := 29; 
  start[239] := 29; 
  
  start[240] := 29; 
  start[241] := 29; 
  start[242] := 29; 
  start[243] := 29; 
  
  start[244] := 29; 
  start[245] := 29; 
  start[246] := 29; 
  start[247] := 29; 
  
  start[248] := 29; 
  start[249] := 29; 
  start[250] := 29; 
  start[251] := 29; 
  
  start[252] := 29; 
  start[253] := 29; 
  start[254] := 29; 
  start[255] := 29; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TpcCocoImportTestScanner.Destroy;
begin
  if (src <> nil) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TpcCocoImportTestScanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 31 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end. (* pcCocoImportTestScanner *)
